Whamcloud - gitweb
LU-12752 mdt: commitrw_write() - check dying object under lock
[fs/lustre-release.git] / lustre / tests / sanity.sh
index c5995a4..865cac4 100755 (executable)
@@ -1641,7 +1641,7 @@ test_27ce() {
        [[ $($LCTL get_param mdc.*.import) =~ connect_flags.*overstriping ]] ||
                skip "server does not support overstriping"
        # We do one more stripe than we have OSTs
-       [ $OSTCOUNT -ge 159 ] || large_xattr_enabled ||
+       [ $OSTCOUNT -lt 159 ] || large_xattr_enabled ||
                skip_env "ea_inode feature disabled"
 
        test_mkdir -p $DIR/$tdir
@@ -1908,6 +1908,57 @@ test_27o() {
 }
 run_test 27o "create file with all full OSTs (should error)"
 
+function create_and_checktime() {
+       local fname=$1
+       local loops=$2
+       local i
+
+       for ((i=0; i < $loops; i++)); do
+               local start=$SECONDS
+               multiop $fname-$i Oc
+               ((SECONDS-start < TIMEOUT)) ||
+                       error "creation took " $((SECONDS-$start)) && return 1
+       done
+}
+
+test_27oo() {
+       local mdts=$(comma_list $(mdts_nodes))
+
+       [ $MDS1_VERSION -lt $(version_code 2.13.57) ] &&
+               skip "Need MDS version at least 2.13.57"
+
+       local f0=$DIR/${tfile}-0
+       local f1=$DIR/${tfile}-1
+
+       wait_delete_completed
+
+       # refill precreated objects
+       $LFS setstripe -i0 -c1 $f0
+
+       saved=$(do_facet mds1 $LCTL get_param -n lov.*0000*.qos_threshold_rr)
+       # force QoS allocation policy
+       do_nodes $mdts $LCTL set_param lov.*.qos_threshold_rr=0%
+       stack_trap "do_nodes $mdts $LCTL set_param \
+               lov.*.qos_threshold_rr=$saved" EXIT
+       sleep_maxage
+
+       # one OST is unavailable, but still have few objects preallocated
+       stop ost1
+       stack_trap "start ost1 $(ostdevname 1) $OST_MOUNT_OPTS; \
+               rm -rf $f1 $DIR/$tdir*" EXIT
+
+       for ((i=0; i < 7; i++)); do
+               mkdir $DIR/$tdir$i || error "can't create dir"
+               $LFS setstripe -c$((OSTCOUNT-1)) $DIR/$tdir$i ||
+                       error "can't set striping"
+       done
+       for ((i=0; i < 7; i++)); do
+               create_and_checktime $DIR/$tdir$i/$tfile 100 &
+       done
+       wait
+}
+run_test 27oo "don't let few threads to reserve too many objects"
+
 test_27p() {
        [[ $OSTCOUNT -lt 2 ]] && skip_env "needs >= 2 OSTs"
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -2397,7 +2448,7 @@ test_27Cb() {
 
        test_mkdir -p $DIR/$tdir
        local setcount=$(($OSTCOUNT * 2))
-       [ $setcount -ge 160 ] || large_xattr_enabled ||
+       [ $setcount -lt 160 ] || large_xattr_enabled ||
                skip_env "ea_inode feature disabled"
 
        $LFS setstripe -C $setcount $DIR/$tdir/$tfile ||
@@ -2423,7 +2474,7 @@ test_27Cc() {
        test_mkdir -p $DIR/$tdir
        local setcount=$(($OSTCOUNT - 1))
 
-       [ $setcount -ge 160 ] || large_xattr_enabled ||
+       [ $setcount -lt 160 ] || large_xattr_enabled ||
                skip_env "ea_inode feature disabled"
 
        $LFS setstripe -C $setcount $DIR/$tdir/$tfile ||
@@ -2503,7 +2554,7 @@ test_27Cf() {
        test_mkdir -p $DIR/$tdir
 
        local setcount=$(($OSTCOUNT * 2))
-       [ $setcount -ge 160 ] || large_xattr_enabled ||
+       [ $setcount -lt 160 ] || large_xattr_enabled ||
                skip_env "ea_inode feature disabled"
 
        $LFS setstripe  -C $setcount $DIR/$tdir/ ||
@@ -2721,6 +2772,17 @@ test_27J() {
        local uuid2=$(cat /proc/sys/kernel/random/uuid)
 
        # create foreign file (raw way)
+       ! $LFS setstripe --flags 0xda08 $DIR/$tdir/$tfile ||
+               error "creating $tfile w/ hex flags w/o --foreign should fail"
+
+       ! $LFS setstripe --foreign --flags foo \
+               --xattr ${uuid1}@${uuid2} $DIR/$tdir/$tfile ||
+                       error "creating $tfile with '--flags foo' should fail"
+
+       ! $LFS setstripe --foreign --flags 0xffffffff \
+               --xattr ${uuid1}@${uuid2} $DIR/$tdir/$tfile ||
+                       error "creating $tfile w/ 0xffffffff flags should fail"
+
        create_foreign_file -f $DIR/$tdir/$tfile -x "${uuid1}@${uuid2}" \
                -t 1 -F 0xda08 || error "create_foreign_file failed"
 
@@ -2747,7 +2809,7 @@ test_27J() {
                error "$DIR/$tdir/$tfile: invalid LOV EA foreign value"
 
        # create foreign file (lfs + API)
-       $LFS setstripe --foreign=daos --flags 0xda08 \
+       $LFS setstripe --foreign=none --flags 0xda08 \
                -x "${uuid1}@${uuid2}" $DIR/$tdir/${tfile}2 ||
                error "$DIR/$tdir/${tfile}2: create failed"
 
@@ -2757,7 +2819,7 @@ test_27J() {
        # lfm_length is LOV EA size - sizeof(lfm_magic) - sizeof(lfm_length)
        $LFS getstripe -v $DIR/$tdir/${tfile}2 | grep "lfm_length:.*73" ||
                error "$DIR/$tdir/${tfile}2: invalid LOV EA foreign size"
-       $LFS getstripe -v $DIR/$tdir/${tfile}2 | grep "lfm_type:.*daos" ||
+       $LFS getstripe -v $DIR/$tdir/${tfile}2 | grep "lfm_type:.*none" ||
                error "$DIR/$tdir/${tfile}2: invalid LOV EA foreign type"
        $LFS getstripe -v $DIR/$tdir/${tfile}2 |
                grep "lfm_flags:.*0x0000DA08" ||
@@ -2816,6 +2878,17 @@ test_27K() {
        local uuid2=$(cat /proc/sys/kernel/random/uuid)
 
        # create foreign dir (raw way)
+       ! $LFS setdirstripe --flags 0xda08 $DIR/$tdir/$tdir ||
+               error "creating $tdir w/ hex flags w/o --foreign should fail"
+
+       ! $LFS setdirstripe --foreign --flags foo \
+               --xattr ${uuid1}@${uuid2} $DIR/$tdir/$tdir ||
+                       error "creating $tdir with '--flags foo' should fail"
+
+       ! $LFS setdirstripe --foreign --flags 0xffffffff \
+               --xattr ${uuid1}@${uuid2} $DIR/$tdir/$tdir ||
+                       error "creating $tdir w/ 0xffffffff flags should fail"
+
        create_foreign_dir -d $DIR/$tdir/$tdir -x "${uuid1}@${uuid2}" -t 1 ||
                error "create_foreign_dir FAILED"
 
@@ -2827,7 +2900,8 @@ test_27K() {
                error "$DIR/$tdir/$tdir: invalid LMV EA size"
        parse_foreign_dir -d $DIR/$tdir/$tdir | grep "lmv_foreign_type: 1$" ||
                error "$DIR/$tdir/$tdir: invalid LMV EA type"
-       parse_foreign_dir -d $DIR/$tdir/$tdir | grep "lmv_foreign_flags: 0$" ||
+       parse_foreign_dir -d $DIR/$tdir/$tdir |
+               grep "lmv_foreign_flags: 55813$" ||
                error "$DIR/$tdir/$tdir: invalid LMV EA flags"
        local lmv=$(parse_foreign_dir -d $DIR/$tdir/$tdir |
                grep "lmv_foreign_value: 0x" |
@@ -2837,7 +2911,7 @@ test_27K() {
        [[ $lmv == $lmv2 ]] || error "$DIR/$tdir/$tdir: invalid LMV EA value"
 
        # create foreign dir (lfs + API)
-       $LFS mkdir --foreign=daos --xattr="${uuid1}@${uuid2}" --flags=0xda05 \
+       $LFS mkdir --foreign=none --xattr="${uuid1}@${uuid2}" --flags=0xda05 \
                $DIR/$tdir/${tdir}2 ||
                error "$DIR/$tdir/${tdir}2: create failed"
 
@@ -2848,7 +2922,7 @@ test_27K() {
        # - sizeof(lfm_type) - sizeof(lfm_flags)
        $LFS getdirstripe -v $DIR/$tdir/${tdir}2 | grep "lfm_length:.*73" ||
                error "$DIR/$tdir/${tdir}2: invalid LMV EA size"
-       $LFS getdirstripe -v $DIR/$tdir/${tdir}2 | grep "lfm_type:.*daos" ||
+       $LFS getdirstripe -v $DIR/$tdir/${tdir}2 | grep "lfm_type:.*none" ||
                error "$DIR/$tdir/${tdir}2: invalid LMV EA type"
        $LFS getdirstripe -v $DIR/$tdir/${tdir}2 |
                grep "lfm_flags:.*0x0000DA05" ||
@@ -3047,6 +3121,204 @@ test_27N() {
 }
 run_test 27N "lctl pool_list on separate MGS gives correct pool name"
 
+clean_foreign_symlink() {
+       trap 0
+       lctl set_param llite/$FSNAME-*/foreign_symlink_enable=0
+       for i in $DIR/$tdir/* ; do
+               $LFS unlink_foreign $i || true
+       done
+}
+
+test_27O() {
+       [[ $(lustre_version_code $SINGLEMDS) -le $(version_code 2.12.51) ]] &&
+               skip "Need MDS version newer than 2.12.51"
+
+       test_mkdir $DIR/$tdir
+       local uuid1=$(cat /proc/sys/kernel/random/uuid)
+       local uuid2=$(cat /proc/sys/kernel/random/uuid)
+
+       trap clean_foreign_symlink EXIT
+
+       # enable foreign_symlink behaviour
+       $LCTL set_param llite/$FSNAME-*/foreign_symlink_enable=1
+
+       # foreign symlink LOV format is a partial path by default
+
+       # create foreign file (lfs + API)
+       $LFS setstripe --foreign=symlink --flags 0xda05 \
+               -x "${uuid1}/${uuid2}" --mode 0600 $DIR/$tdir/${tfile} ||
+               error "$DIR/$tdir/${tfile}: create failed"
+
+       $LFS getstripe -v $DIR/$tdir/${tfile} |
+               grep "lfm_magic:.*0x0BD70BD0" ||
+               error "$DIR/$tdir/${tfile}: invalid LOV EA foreign magic"
+       $LFS getstripe -v $DIR/$tdir/${tfile} | grep "lfm_type:.*symlink" ||
+               error "$DIR/$tdir/${tfile}: invalid LOV EA foreign type"
+       $LFS getstripe -v $DIR/$tdir/${tfile} |
+               grep "lfm_flags:.*0x0000DA05" ||
+               error "$DIR/$tdir/${tfile}: invalid LOV EA foreign flags"
+       $LFS getstripe $DIR/$tdir/${tfile} |
+               grep "lfm_value:.*${uuid1}/${uuid2}" ||
+               error "$DIR/$tdir/${tfile}: invalid LOV EA foreign value"
+
+       # modify striping should fail
+       $LFS setstripe -c 2 $DIR/$tdir/$tfile &&
+               error "$DIR/$tdir/$tfile: setstripe should fail"
+
+       # R/W should fail ("/{foreign_symlink_prefix}/${uuid1}/" missing)
+       cat $DIR/$tdir/$tfile && error "$DIR/$tdir/$tfile: read should fail"
+       cat /etc/passwd > $DIR/$tdir/$tfile &&
+               error "$DIR/$tdir/$tfile: write should fail"
+
+       # rename should succeed
+       mv $DIR/$tdir/$tfile $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/$tfile: rename has failed"
+
+       #remove foreign_symlink file should fail
+       rm $DIR/$tdir/${tfile}.new &&
+               error "$DIR/$tdir/${tfile}.new: remove of foreign_symlink file should fail"
+
+       #test fake symlink
+       mkdir /tmp/${uuid1} ||
+               error "/tmp/${uuid1}: mkdir has failed"
+       echo FOOFOO > /tmp/${uuid1}/${uuid2} ||
+               error "/tmp/${uuid1}/${uuid2}: echo has failed"
+       $LCTL set_param llite/$FSNAME-*/foreign_symlink_prefix=/tmp/
+       $CHECKSTAT -t link -l /tmp/${uuid1}/${uuid2} $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: not seen as a symlink"
+       #read should succeed now
+       cat $DIR/$tdir/${tfile}.new | grep FOOFOO ||
+               error "$DIR/$tdir/${tfile}.new: symlink resolution has failed"
+       #write should succeed now
+       cat /etc/passwd > $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: write should succeed"
+       diff /etc/passwd $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: diff has failed"
+       diff /etc/passwd /tmp/${uuid1}/${uuid2} ||
+               error "/tmp/${uuid1}/${uuid2}: diff has failed"
+
+       #check that getstripe still works
+       $LFS getstripe $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: getstripe should still work with foreign_symlink enabled"
+
+       # chmod should still succeed
+       chmod 644 $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: chmod has failed"
+
+       # chown should still succeed
+       chown $RUNAS_ID:$RUNAS_GID $DIR/$tdir/${tfile}.new ||
+               error "$DIR/$tdir/${tfile}.new: chown has failed"
+
+       # rename should still succeed
+       mv $DIR/$tdir/${tfile}.new $DIR/$tdir/${tfile} ||
+               error "$DIR/$tdir/${tfile}.new: rename has failed"
+
+       #remove foreign_symlink file should still fail
+       rm $DIR/$tdir/${tfile} &&
+               error "$DIR/$tdir/${tfile}: remove of foreign_symlink file should fail"
+
+       #use special ioctl() to unlink foreign_symlink file
+       $LFS unlink_foreign $DIR/$tdir/${tfile} ||
+               error "$DIR/$tdir/$tfile: unlink/ioctl failed"
+
+}
+run_test 27O "basic ops on foreign file of symlink type"
+
+test_27P() {
+       [[ $(lustre_version_code $SINGLEMDS) -le $(version_code 2.12.49) ]] &&
+               skip "Need MDS version newer than 2.12.49"
+
+       test_mkdir $DIR/$tdir
+       local uuid1=$(cat /proc/sys/kernel/random/uuid)
+       local uuid2=$(cat /proc/sys/kernel/random/uuid)
+
+       trap clean_foreign_symlink EXIT
+
+       # enable foreign_symlink behaviour
+       $LCTL set_param llite/$FSNAME-*/foreign_symlink_enable=1
+
+       # foreign symlink LMV format is a partial path by default
+
+       # create foreign dir (lfs + API)
+       $LFS mkdir --foreign=symlink --xattr="${uuid1}/${uuid2}" \
+               --flags=0xda05 --mode 0750 $DIR/$tdir/${tdir} ||
+               error "$DIR/$tdir/${tdir}: create failed"
+
+       $LFS getdirstripe -v $DIR/$tdir/${tdir} |
+               grep "lfm_magic:.*0x0CD50CD0" ||
+               error "$DIR/$tdir/${tdir}: invalid LMV EA magic"
+       $LFS getdirstripe -v $DIR/$tdir/${tdir} | grep "lfm_type:.*symlink" ||
+               error "$DIR/$tdir/${tdir}: invalid LMV EA type"
+       $LFS getdirstripe -v $DIR/$tdir/${tdir} |
+               grep "lfm_flags:.*0x0000DA05" ||
+               error "$DIR/$tdir/${tdir}: invalid LMV EA flags"
+       $LFS getdirstripe $DIR/$tdir/${tdir} |
+               grep "lfm_value.*${uuid1}/${uuid2}" ||
+               error "$DIR/$tdir/${tdir}: invalid LMV EA value"
+
+       # file create in dir should fail
+       # ("/{foreign_symlink_prefix}/${uuid1}/${uuid2}/" missing)
+       touch $DIR/$tdir/$tdir/$tfile && "$DIR/$tdir: file create should fail"
+
+       # rename should succeed
+       mv $DIR/$tdir/$tdir $DIR/$tdir/${tdir}.new ||
+               error "$DIR/$tdir/$tdir: rename of foreign_symlink dir has failed"
+
+       #remove foreign_symlink dir should fail
+       rmdir $DIR/$tdir/${tdir}.new &&
+               error "$DIR/$tdir/${tdir}.new: remove of foreign_symlink dir should fail"
+
+       #test fake symlink
+       mkdir -p /tmp/${uuid1}/${uuid2} ||
+               error "/tmp/${uuid1}/${uuid2}: mkdir has failed"
+       echo FOOFOO > /tmp/${uuid1}/${uuid2}/foo ||
+               error "/tmp/${uuid1}/${uuid2}/foo: echo has failed"
+       $LCTL set_param llite/$FSNAME-*/foreign_symlink_prefix=/tmp/
+       $CHECKSTAT -t link -l /tmp/${uuid1}/${uuid2} $DIR/$tdir/${tdir}.new ||
+               error "$DIR/$tdir/${tdir}.new: not seen as a symlink"
+       cat $DIR/$tdir/${tdir}.new/foo | grep FOOFOO ||
+               error "$DIR/$tdir/${tdir}.new: symlink resolution has failed"
+
+       #check that getstripe fails now that foreign_symlink enabled
+       $LFS getdirstripe $DIR/$tdir/${tdir}.new ||
+               error "$DIR/$tdir/${tdir}.new: getdirstripe should still work with foreign_symlink enabled"
+
+       # file create in dir should work now
+       cp /etc/passwd $DIR/$tdir/${tdir}.new/$tfile ||
+               error "$DIR/$tdir/${tdir}.new/$tfile: file create should fail"
+       diff /etc/passwd $DIR/$tdir/${tdir}.new/$tfile ||
+               error "$DIR/$tdir/${tdir}.new/$tfile: diff has failed"
+       diff /etc/passwd /tmp/${uuid1}/${uuid2}/$tfile ||
+               error "/tmp/${uuid1}/${uuid2}/$tfile: diff has failed"
+
+       # chmod should still succeed
+       chmod 755 $DIR/$tdir/${tdir}.new ||
+               error "$DIR/$tdir/${tdir}.new: chmod has failed"
+
+       # chown should still succeed
+       chown $RUNAS_ID:$RUNAS_GID $DIR/$tdir/${tdir}.new ||
+               error "$DIR/$tdir/${tdir}.new: chown has failed"
+
+       # rename should still succeed
+       mv $DIR/$tdir/${tdir}.new $DIR/$tdir/${tdir} ||
+               error "$DIR/$tdir/${tdir}.new: rename of foreign_symlink dir has failed"
+
+       #remove foreign_symlink dir should still fail
+       rmdir $DIR/$tdir/${tdir} &&
+               error "$DIR/$tdir/${tdir}: remove of foreign_symlink dir should fail"
+
+       #use special ioctl() to unlink foreign_symlink file
+       $LFS unlink_foreign $DIR/$tdir/${tdir} ||
+               error "$DIR/$tdir/$tdir: unlink/ioctl failed"
+
+       #created file should still exist
+       [[ -f /tmp/${uuid1}/${uuid2}/$tfile ]] ||
+               error "/tmp/${uuid1}/${uuid2}/$tfile has been removed"
+       diff /etc/passwd /tmp/${uuid1}/${uuid2}/$tfile ||
+               error "/tmp/${uuid1}/${uuid2}/$tfile: diff has failed"
+}
+run_test 27P "basic ops on foreign dir of foreign_symlink type"
+
 # createtest also checks that device nodes are created and
 # then visible correctly (#2091)
 test_28() { # bug 2091
@@ -4970,17 +5242,14 @@ test_44A() { # was test_44
 run_test 44A "zero length read from a sparse stripe"
 
 test_44a() {
-       local nstripe=$($LCTL lov_getconfig $DIR | grep default_stripe_count: |
-               awk '{ print $2 }')
+       local nstripe=$($LFS getstripe -c -d $DIR)
        [ -z "$nstripe" ] && skip "can't get stripe info"
        [[ $nstripe -gt $OSTCOUNT ]] &&
-               skip "Wrong default_stripe_count: $nstripe OSTCOUNT: $OSTCOUNT"
+               skip "Wrong default stripe_count: $nstripe OSTCOUNT: $OSTCOUNT"
 
-       local stride=$($LCTL lov_getconfig $DIR | grep default_stripe_size: |
-               awk '{ print $2 }')
+       local stride=$($LFS getstripe -S -d $DIR)
        if [[ $nstripe -eq 0 || $nstripe -eq -1 ]]; then
-               nstripe=$($LCTL lov_getconfig $DIR | grep obd_count: |
-                       awk '{ print $2 }')
+               nstripe=$($LFS df $DIR | grep OST: | wc -l)
        fi
 
        OFFSETS="0 $((stride/2)) $((stride-1))"
@@ -10501,6 +10770,21 @@ test_103c() {
 }
 run_test 103c "'cp -rp' won't set empty acl"
 
+test_103e() {
+       (( $MDS1_VERSION >= $(version_code 2.13.59) )) ||
+               skip "MDS needs to be at least 2.13.59"
+
+       mkdir -p $DIR/$tdir
+       # one default ACL will be created for the file owner
+       for U in {2..256}; do
+               setfacl -m default:user:$U:rwx $DIR/$tdir
+               numacl=$(getfacl $DIR/$tdir |& grep -c "default:user")
+               touch $DIR/$tdir/$tfile.$U ||
+                       error "failed to create $tfile.$U with $numacl ACLs"
+       done
+}
+run_test 103e "inheritance of big amount of default ACLs"
+
 test_104a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
@@ -14686,12 +14970,14 @@ test_160f() {
        local i
 
        # generate some changelog records to accumulate on each MDT
-       # use fnv1a because created files should be evenly distributed
-       test_mkdir -c $MDSCOUNT -H fnv_1a_64 $DIR/$tdir ||
+       # use all_char because created files should be evenly distributed
+       test_mkdir -c $MDSCOUNT -H all_char $DIR/$tdir ||
                error "test_mkdir $tdir failed"
        log "$(date +%s): creating first files"
-       createmany -m $DIR/$tdir/$tfile $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/$tfile failed"
+       for ((i = 0; i < MDSCOUNT * 2; i++)); do
+               $LFS mkdir -i $((i%MDSCOUNT)) $DIR/$tdir/d$i.$((i/MDSCOUNT)) ||
+                       error "create $DIR/$tdir/d$i.$((i/MDSCOUNT)) failed"
+       done
 
        # check changelogs have been generated
        local start=$SECONDS
@@ -14719,7 +15005,7 @@ test_160f() {
 
        # simulate changelog catalog almost full
        #define OBD_FAIL_CAT_FREE_RECORDS       0x1313
-       do_nodes $mdts $LCTL set_param fail_loc=0x1313 fail_val=3
+       do_nodes $mdts "$LCTL set_param fail_loc=0x1313 fail_val=3"
 
        for i in $(seq $MDSCOUNT); do
                cl_users=(${CL_USERS[mds$i]})
@@ -14759,18 +15045,19 @@ test_160f() {
        # Generate one more changelog to trigger GC at fail_loc for cl_user2.
        # cl_user1 should be OK because it recently processed records.
        echo "$(date +%s): creating $((MDSCOUNT * 2)) files"
-       createmany -m $DIR/$tdir/${tfile}b $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/${tfile}b failed"
+       for ((i = 0; i < MDSCOUNT * 2; i++)); do
+               $LFS mkdir -i $((i%MDSCOUNT)) $DIR/$tdir/d$i.$((i/MDSCOUNT+2))||
+                       error "create $DIR/$tdir/d$i.$((i/MDSCOUNT+2)) failed"
+       done
 
        # ensure gc thread is done
        for i in $(mdts_nodes); do
-               wait_update $i \
-                       "ps -e -o comm= | grep chlg_gc_thread" "" 20 ||
+               wait_update $i "ps -e -o comm= | grep chlg_gc_thread" "" 20 ||
                        error "$i: GC-thread not done"
        done
 
        local first_rec
-       for i in $(seq $MDSCOUNT); do
+       for (( i = 1; i <= MDSCOUNT; i++ )); do
                # check cl_user1 still registered
                changelog_users mds$i | grep -q "${cl_user1[mds$i]}" ||
                        error "mds$i: User ${cl_user1[mds$i]} not registered"
@@ -14785,10 +15072,9 @@ test_160f() {
                first_rec=$($LFS changelog $(facet_svc mds$i) |
                            awk '{ print $1; exit; }')
 
-               echo "mds$i: verifying first index $user_rec1 + 1 == $first_rec"
+               echo "mds$i: $(date +%s) verify rec $user_rec1+1 == $first_rec"
                [ $((user_rec1 + 1)) == $first_rec ] ||
-                       error "mds$i: first index should be $user_rec1 + 1, " \
-                             "but is $first_rec"
+                       error "mds$i: rec $first_rec != $user_rec1 + 1"
        done
 }
 run_test 160f "changelog garbage collect (timestamped users)"
@@ -14814,20 +15100,20 @@ test_160g() {
        local i
 
        # generate some changelog records to accumulate on each MDT
-       # use fnv1a because created files should be evenly distributed
-       test_mkdir -c $MDSCOUNT -H fnv_1a_64 $DIR/$tdir ||
-               error "mkdir $tdir failed"
-       createmany -m $DIR/$tdir/$tfile $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/$tfile failed"
+       # use all_char because created files should be evenly distributed
+       test_mkdir -c $MDSCOUNT -H all_char $DIR/$tdir ||
+               error "test_mkdir $tdir failed"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               $LFS mkdir -i $i $DIR/$tdir/d$i.1 $DIR/$tdir/d$i.2 ||
+                       error "create $DIR/$tdir/d$i.1 failed"
+       done
 
        # check changelogs have been generated
        local nbcl=$(changelog_dump | wc -l)
-       [[ $nbcl -eq 0 ]] && error "no changelogs found"
+       (( $nbcl > 0 )) || error "no changelogs found"
 
        # reduce the max_idle_indexes value to make sure we exceed it
-       max_ndx=$((nbcl / 2 - 1))
-
-       for param in "changelog_max_idle_indexes=$max_ndx" \
+       for param in "changelog_max_idle_indexes=1" \
                     "changelog_gc=1" \
                     "changelog_min_gc_interval=2" \
                     "changelog_min_free_cat_entries=3"; do
@@ -14842,8 +15128,9 @@ test_160g() {
 
        # simulate changelog catalog almost full
        #define OBD_FAIL_CAT_FREE_RECORDS       0x1313
-       do_nodes $mdts $LCTL set_param fail_loc=0x1313 fail_val=3
+       do_nodes $mdts "$LCTL set_param fail_loc=0x1313 fail_val=3"
 
+       local start=$SECONDS
        for i in $(seq $MDSCOUNT); do
                cl_users=(${CL_USERS[mds$i]})
                cl_user1[mds$i]="${cl_users[0]}"
@@ -14875,21 +15162,24 @@ test_160g() {
        done
 
        # ensure we are past the previous changelog_min_gc_interval set above
-       sleep 2
+       local sleep2=$((start + 2 - SECONDS))
+       (( sleep2 > 0 )) && echo "sleep $sleep2 for interval" && sleep $sleep2
 
-       # generate one more changelog to trigger fail_loc
-       createmany -m $DIR/$tdir/${tfile}bis $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/${tfile}bis failed"
+       # Generate one more changelog to trigger GC at fail_loc for cl_user2.
+       # cl_user1 should be OK because it recently processed records.
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               $LFS mkdir -i $i $DIR/$tdir/d$i.3 $DIR/$tdir/d$i.4 ||
+                       error "create $DIR/$tdir/d$i.3 failed"
+       done
 
        # ensure gc thread is done
        for i in $(mdts_nodes); do
-               wait_update $i \
-                       "ps -e -o comm= | grep chlg_gc_thread" "" 20 ||
+               wait_update $i "ps -e -o comm= | grep chlg_gc_thread" "" 20 ||
                        error "$i: GC-thread not done"
        done
 
        local first_rec
-       for i in $(seq $MDSCOUNT); do
+       for (( i = 1; i <= MDSCOUNT; i++ )); do
                # check cl_user1 still registered
                changelog_users mds$i | grep -q "${cl_user1[mds$i]}" ||
                        error "mds$i: User ${cl_user1[mds$i]} not registered"
@@ -14904,10 +15194,9 @@ test_160g() {
                first_rec=$($LFS changelog $(facet_svc mds$i) |
                            awk '{ print $1; exit; }')
 
-               echo "mds$i: verifying first index $user_rec1 + 1 == $first_rec"
+               echo "mds$i: $(date +%s) verify rec $user_rec1+1 == $first_rec"
                [ $((user_rec1 + 1)) == $first_rec ] ||
-                       error "mds$i: first index should be $user_rec1 + 1, " \
-                             "but is $first_rec"
+                       error "mds$i: rec $first_rec != $user_rec1 + 1"
        done
 }
 run_test 160g "changelog garbage collect (old users)"
@@ -14930,11 +15219,13 @@ test_160h() {
        local i
 
        # generate some changelog records to accumulate on each MDT
-       # use fnv1a because created files should be evenly distributed
-       test_mkdir -c $MDSCOUNT -H fnv_1a_64 $DIR/$tdir ||
+       # use all_char because created files should be evenly distributed
+       test_mkdir -c $MDSCOUNT -H all_char $DIR/$tdir ||
                error "test_mkdir $tdir failed"
-       createmany -m $DIR/$tdir/$tfile $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/$tfile failed"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               $LFS mkdir -i $i $DIR/$tdir/d$i.1 $DIR/$tdir/d$i.2 ||
+                       error "create $DIR/$tdir/d$i.1 failed"
+       done
 
        # check changelogs have been generated
        local nbcl=$(changelog_dump | wc -l)
@@ -15081,11 +15372,13 @@ test_160i() {
        changelog_register || error "first changelog_register failed"
 
        # generate some changelog records to accumulate on each MDT
-       # use fnv1a because created files should be evenly distributed
-       test_mkdir -c $MDSCOUNT -H fnv_1a_64 $DIR/$tdir ||
-               error "mkdir $tdir failed"
-       createmany -m $DIR/$tdir/$tfile $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/$tfile failed"
+       # use all_char because created files should be evenly distributed
+       test_mkdir -c $MDSCOUNT -H all_char $DIR/$tdir ||
+               error "test_mkdir $tdir failed"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               $LFS mkdir -i $i $DIR/$tdir/d$i.1 $DIR/$tdir/d$i.2 ||
+                       error "create $DIR/$tdir/d$i.1 failed"
+       done
 
        # check changelogs have been generated
        local nbcl=$(changelog_dump | wc -l)
@@ -15148,11 +15441,13 @@ test_160j() {
        stack_trap "changelog_deregister" EXIT
 
        # generate some changelog
-       # use fnv1a because created files should be evenly distributed
-       test_mkdir -c $MDSCOUNT -H fnv_1a_64 $DIR/$tdir ||
+       # use all_char because created files should be evenly distributed
+       test_mkdir -c $MDSCOUNT -H all_char $DIR/$tdir ||
                error "mkdir $tdir failed"
-       createmany -m $DIR/$tdir/${tfile}bis $((MDSCOUNT * 2)) ||
-               error "create $DIR/$tdir/${tfile}bis failed"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               $LFS mkdir -i $i $DIR/$tdir/d$i.1 $DIR/$tdir/d$i.2 ||
+                       error "create $DIR/$tdir/d$i.1 failed"
+       done
 
        # open the changelog device
        exec 3>/dev/changelog-$FSNAME-MDT0000
@@ -15164,8 +15459,8 @@ test_160j() {
        umount $MOUNT
        stack_trap "mount_client $MOUNT" EXIT
 
-       # read changelog
-       cat <&4 >/dev/null || error "read changelog failed"
+       # read changelog, which may or may not fail, but should not crash
+       cat <&4 >/dev/null
 
        # clear changelog
        local cl_user="${CL_USERS[$SINGLEMDS]%% *}"
@@ -15174,7 +15469,7 @@ test_160j() {
 
        printf 'clear:'$cl_user':0' >&3
 }
-run_test 160j "client can be umounted  while its chanangelog is being used"
+run_test 160j "client can be umounted while its chanangelog is being used"
 
 test_160k() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -15198,9 +15493,6 @@ test_160k() {
        sleep 4
 
        changelog_dump | grep rmdir || error "rmdir not recorded"
-
-       rm -rf $DIR/$tdir
-       changelog_deregister
 }
 run_test 160k "Verify that changelog records are not lost"
 
@@ -18531,13 +18823,11 @@ test_230o() {
 
        local mdts=$(comma_list $(mdts_nodes))
        local timeout=100
-
        local restripe_status
        local delta
        local i
-       local j
 
-       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+       [[ $mds1_FSTYPE == zfs ]] && timeout=300
 
        # in case "crush" hash type is not set
        do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
@@ -18555,7 +18845,7 @@ test_230o() {
                error "create dirs under remote dir failed $i"
 
        for i in $(seq 2 $MDSCOUNT); do
-               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear >/dev/null"
                $LFS setdirstripe -c $i $DIR/$tdir ||
                        error "split -c $i $tdir failed"
                wait_update $HOSTNAME \
@@ -18563,10 +18853,10 @@ test_230o() {
                        error "dir split not finished"
                delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
                        awk '/migrate/ {sum += $2} END { print sum }')
-               echo "$delta files migrated when dir split from $((i - 1)) to $i stripes"
+               echo "$delta migrated when dir split $((i - 1)) to $i stripes"
                # delta is around total_files/stripe_count
-               [ $delta -lt $((200 /(i - 1))) ] ||
-                       error "$delta files migrated"
+               (( $delta < 200 / (i - 1) + 4 )) ||
+                       error "$delta files migrated >= $((200 / (i - 1) + 4))"
        done
 }
 run_test 230o "dir split"
@@ -18578,13 +18868,11 @@ test_230p() {
 
        local mdts=$(comma_list $(mdts_nodes))
        local timeout=100
-
        local restripe_status
        local delta
        local i
-       local j
 
-       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+       [[ $mds1_FSTYPE == zfs ]] && timeout=300
 
        do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
 
@@ -18603,7 +18891,7 @@ test_230p() {
        for i in $(seq $((MDSCOUNT - 1)) -1 1); do
                local mdt_hash="crush"
 
-               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear >/dev/null"
                $LFS setdirstripe -c $i $DIR/$tdir ||
                        error "split -c $i $tdir failed"
                [ $i -eq 1 ] && mdt_hash="none"
@@ -18612,10 +18900,10 @@ test_230p() {
                        error "dir merge not finished"
                delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
                        awk '/migrate/ {sum += $2} END { print sum }')
-               echo "$delta files migrated when dir merge from $((i + 1)) to $i stripes"
+               echo "$delta migrated when dir merge $((i + 1)) to $i stripes"
                # delta is around total_files/stripe_count
-               [ $delta -lt $((200 / i)) ] ||
-                       error "$delta files migrated"
+               (( $delta < 200 / i + 4 )) ||
+                       error "$delta files migrated >= $((200 / i + 4))"
        done
 }
 run_test 230p "dir merge"
@@ -18636,6 +18924,7 @@ test_230q() {
        local stripe_count=0
        local stripe_index
        local nr_files
+       local create
 
        # test with fewer files on ZFS
        [ "$mds1_FSTYPE" == "zfs" ] && threshold=40
@@ -18654,11 +18943,12 @@ test_230q() {
        $LFS mkdir -i -1 -c 1 $DIR/$tdir || error "mkdir $tdir failed"
        stripe_index=$($LFS getdirstripe -i $DIR/$tdir)
 
+       create=$((threshold * 3 / 2))
        while [ $stripe_count -lt $MDSCOUNT ]; do
-               createmany -m $DIR/$tdir/f $total $((threshold * 3 / 2)) ||
+               createmany -m $DIR/$tdir/f $total $create ||
                        error "create sub files failed"
                stat $DIR/$tdir > /dev/null
-               total=$((total + threshold * 3 / 2))
+               total=$((total + create))
                stripe_count=$((stripe_count + delta))
                [ $stripe_count -gt $MDSCOUNT ] && stripe_count=$MDSCOUNT
 
@@ -18670,13 +18960,13 @@ test_230q() {
                        "$LFS getdirstripe -H $DIR/$tdir" "crush" 200 ||
                        error "stripe hash $($LFS getdirstripe -H $DIR/$tdir) != crush"
 
-               nr_files=$($LFS getstripe -m $DIR/$tdir/* |
-                          grep -w $stripe_index | wc -l)
-               echo "$nr_files files on MDT$stripe_index after split"
-               [ $nr_files -lt $((total / (stripe_count - 1))) ] ||
+               nr_files=$($LFS find -m 1 $DIR/$tdir | grep -c -w $stripe_index)
+               echo "$nr_files/$total files on MDT$stripe_index after split"
+               # allow 10% margin of imbalance with crush hash
+               (( $nr_files <= $total / $stripe_count + $create / 10)) ||
                        error "$nr_files files on MDT$stripe_index after split"
 
-               nr_files=$(ls $DIR/$tdir | wc -w)
+               nr_files=$($LFS find -type f $DIR/$tdir | wc -l)
                [ $nr_files -eq $total ] ||
                        error "total sub files $nr_files != $total"
        done
@@ -19235,6 +19525,8 @@ test_247f() {
        [ $MDSCOUNT -lt 2 ] && skip_env "needs >= 2 MDTs"
        [ $MDS1_VERSION -lt $(version_code 2.13.52) ] &&
                skip "Need at least version 2.13.52"
+       [ $CLIENT_VERSION -lt $(version_code 2.14.50) ] &&
+               skip "Need at least version 2.14.50"
        lctl get_param -n mdc.$FSNAME-MDT0000*.import |
                grep -q subtree ||
                skip "Fileset feature is not supported"
@@ -19243,26 +19535,78 @@ test_247f() {
        $LFS mkdir -i $((MDSCOUNT - 1)) $DIR/$tdir/remote ||
                error "mkdir remote failed"
        mkdir $DIR/$tdir/remote/subdir || error "mkdir remote/subdir failed"
-       $LFS mkdir -c $MDSCOUNT $DIR/$tdir/striped ||
+       $LFS mkdir -i 0 -c $MDSCOUNT $DIR/$tdir/striped ||
                error "mkdir striped failed"
        mkdir $DIR/$tdir/striped/subdir || error "mkdir striped/subdir failed"
 
        local submount=${MOUNT}_$tdir
 
        mkdir -p $submount || error "mkdir $submount failed"
+       stack_trap "rmdir $submount"
 
        local dir
+       local stat
        local fileset=$FILESET
+       local mdts=$(comma_list $(mdts_nodes))
+
+       stat=$(do_facet mds1 $LCTL get_param -n \
+               mdt.*MDT0000.enable_remote_subdir_mount)
+       stack_trap "do_nodes $mdts $LCTL set_param \
+               mdt.*.enable_remote_subdir_mount=$stat"
+
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_remote_subdir_mount=0"
+       stack_trap "umount_client $submount"
+       FILESET="$fileset/$tdir/remote" mount_client $submount &&
+               error "mount remote dir $dir should fail"
 
-       for dir in $tdir/remote $tdir/remote/subdir \
-                  $tdir/striped $tdir/striped/subdir $tdir/striped/. ; do
+       for dir in $tdir/remote/subdir $tdir/striped $tdir/striped/subdir \
+               $tdir/striped/. ; do
                FILESET="$fileset/$dir" mount_client $submount ||
                        error "mount $dir failed"
                umount_client $submount
        done
+
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_remote_subdir_mount=1"
+       FILESET="$fileset/$tdir/remote" mount_client $submount ||
+               error "mount $tdir/remote failed"
 }
 run_test 247f "mount striped or remote directory as fileset"
 
+test_247g() {
+       [ $MDSCOUNT -lt 4 ] && skip_env "needs >= 4 MDTs"
+       [ $CLIENT_VERSION -lt $(version_code 2.14.50) ] &&
+               skip "Need at least version 2.14.50"
+
+       $LFS mkdir -i 0 -c 4 -H fnv_1a_64 $DIR/$tdir ||
+               error "mkdir $tdir failed"
+       touch $DIR/$tdir/$tfile || error "touch $tfile failed"
+
+       local submount=${MOUNT}_$tdir
+
+       mkdir -p $submount || error "mkdir $submount failed"
+       stack_trap "rmdir $submount"
+
+       FILESET="$fileset/$tdir" mount_client $submount ||
+               error "mount $dir failed"
+       stack_trap "umount $submount"
+
+       local mdts=$(comma_list $(mdts_nodes))
+
+       local nrpcs
+
+       stat $submount > /dev/null
+       cancel_lru_locks $MDC
+       stat $submount > /dev/null
+       stat $submount/$tfile > /dev/null
+       do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+       stat $submount/$tfile > /dev/null
+       nrpcs=$(do_nodes $mdts "lctl get_param -n mdt.*.md_stats" |
+               awk '/getattr/ {sum += $2} END {print sum}')
+
+       [ -z "$nrpcs" ] || error "$nrpcs extra getattr sent"
+}
+run_test 247g "mount striped directory as fileset caches ROOT lookup lock"
+
 test_248a() {
        local fast_read_sav=$($LCTL get_param -n llite.*.fast_read 2>/dev/null)
        [ -z "$fast_read_sav" ] && skip "no fast read support"
@@ -19863,6 +20207,9 @@ test_255c() {
        [ $OST1_VERSION -lt $(version_code 2.10.50) ] &&
                skip "lustre < 2.10.50 does not support lockahead"
 
+       local ost1_imp=$(get_osc_import_name client ost1)
+       local imp_name=$($LCTL list_param osc.$ost1_imp | head -n1 |
+                        cut -d'.' -f2)
        local count
        local new_count
        local difference
@@ -19910,7 +20257,7 @@ test_255c() {
                cancel_lru_locks osc
 
                count=$($LCTL get_param -n \
-                      ldlm.namespaces.$FSNAME-OST0000*osc-[-0-9a-f]*.lock_unused_count)
+                      ldlm.namespaces.$imp_name.lock_unused_count)
 
                lockahead_test -d $DIR/$tdir -t $i -f $tfile
                rc=$?
@@ -19919,7 +20266,7 @@ test_255c() {
                fi
 
                new_count=$($LCTL get_param -n \
-                      ldlm.namespaces.$FSNAME-OST0000*osc-[-0-9a-f]*.lock_unused_count)
+                      ldlm.namespaces.$imp_name.lock_unused_count)
                difference="$((new_count - count))"
 
                # Test 15 output is divided by 100 to map down to valid return
@@ -21003,6 +21350,17 @@ test_273a() {
 }
 run_test 273a "DoM: layout swapping should fail with DOM"
 
+test_273b() {
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -E 1M -L mdt -E -1 -c -1 $DIR/$tdir
+
+#define OBD_FAIL_MDS_COMMITRW_DELAY      0x16b
+       do_facet mds1 $LCTL set_param fail_loc=0x8000016b fail_val=2
+
+       $MULTIOP $DIR/$tdir/$tfile Ouw2097152c
+}
+run_test 273b "DoM: race writeback and object destroy"
+
 test_275() {
        remote_ost_nodsh && skip "remote OST with nodsh"
        [ $OST1_VERSION -lt $(version_code 2.10.57) ] &&
@@ -22326,6 +22684,10 @@ test_319() {
 run_test 319 "lost lease lock on migrate error"
 
 test_398a() { # LU-4198
+       local ost1_imp=$(get_osc_import_name client ost1)
+       local imp_name=$($LCTL list_param osc.$ost1_imp | head -n1 |
+                        cut -d'.' -f2)
+
        $LFS setstripe -c 1 -i 0 $DIR/$tfile
        $LCTL set_param ldlm.namespaces.*.lru_size=clear
 
@@ -22334,7 +22696,7 @@ test_398a() { # LU-4198
 
        dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 oflag=direct conv=notrunc
        local lock_count=$($LCTL get_param -n \
-                          ldlm.namespaces.*-OST0000-osc-ffff*.lru_size)
+                          ldlm.namespaces.$imp_name.lru_size)
        [[ $lock_count -eq 0 ]] || error "lock should be cancelled by direct IO"
 
        $LCTL set_param ldlm.namespaces.*-OST0000-osc-ffff*.lru_size=clear
@@ -22342,7 +22704,7 @@ test_398a() { # LU-4198
        # no lock cached, should use lockless IO and not enqueue new lock
        dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 oflag=direct conv=notrunc
        lock_count=$($LCTL get_param -n \
-                    ldlm.namespaces.*-OST0000-osc-ffff*.lru_size)
+                    ldlm.namespaces.$imp_name.lru_size)
        [[ $lock_count -eq 0 ]] || error "no lock should be held by direct IO"
 }
 run_test 398a "direct IO should cancel lock otherwise lockless"
@@ -22374,6 +22736,10 @@ test_398b() { # LU-4198
 run_test 398b "DIO and buffer IO race"
 
 test_398c() { # LU-4198
+       local ost1_imp=$(get_osc_import_name client ost1)
+       local imp_name=$($LCTL list_param osc.$ost1_imp | head -n1 |
+                        cut -d'.' -f2)
+
        which fio || skip_env "no fio installed"
 
        saved_debug=$($LCTL get_param -n debug)
@@ -22402,8 +22768,7 @@ test_398c() { # LU-4198
                --filename=$DIR/$tfile
        [ $? -eq 0 ] || error "fio write error"
 
-       [ $($LCTL get_param -n \
-        ldlm.namespaces.${FSNAME}-OST0000-osc-ffff*.lock_count) -eq 0 ] ||
+       [ $($LCTL get_param -n ldlm.namespaces.$imp_name.lock_count) -eq 0 ] ||
                error "Locks were requested while doing AIO"
 
        # get the percentage of 1-page I/O
@@ -23836,6 +24201,38 @@ test_426() {
 }
 run_test 426 "splice test on Lustre"
 
+test_427() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       (( $MDS1_VERSION >= $(version_code 2.12.4) )) ||
+               skip "Need MDS version at least 2.12.4"
+       local log
+
+       mkdir $DIR/$tdir
+       mkdir $DIR/$tdir/1
+       mkdir $DIR/$tdir/2
+       test_mkdir -c $MDSCOUNT -i 1 $DIR/$tdir/1/dir
+       test_mkdir -c $MDSCOUNT -i 1 $DIR/$tdir/2/dir2
+
+       $LFS getdirstripe $DIR/$tdir/1/dir
+
+       #first setfattr for creating updatelog
+       setfattr -n user.attr0 -v "some text" $DIR/$tdir/1/dir
+
+#define OBD_FAIL_OUT_OBJECT_MISS        0x1708
+       do_nodes $(comma_list $(mdts_nodes)) $LCTL set_param fail_loc=0x80001708
+       setfattr -n user.attr1 -v "some text" $DIR/$tdir/1/dir &
+       setfattr -n user.attr2 -v "another attr"  $DIR/$tdir/2/dir2 &
+
+       sleep 2
+       fail mds2
+       wait_recovery_complete mds2 $((2*TIMEOUT))
+
+       log=$(do_facet mds1 dmesg | tac | sed "/${TESTNAME//_/ }/,$ d")
+       echo $log | grep "get update log failed" &&
+               error "update log corruption is detected" || true
+}
+run_test 427 "Failed DNE2 update request shouldn't corrupt updatelog"
+
 lseek_test_430() {
        local offset
        local file=$1
@@ -25098,8 +25495,13 @@ test_815()
 run_test 815 "zero byte tiny write doesn't hang (LU-12382)"
 
 test_816() {
+       local ost1_imp=$(get_osc_import_name client ost1)
+       local imp_name=$($LCTL list_param osc.$ost1_imp | head -n1 |
+                        cut -d'.' -f2)
+
        $LFS setstripe -c 1 -i 0 $DIR/$tfile
        # ensure ost1 is connected
+
        stat $DIR/$tfile >/dev/null || error "can't stat"
        wait_osc_import_state client ost1 FULL
        # no locks, no reqs to let the connection idle
@@ -25108,12 +25510,12 @@ test_816() {
        local before
        local now
        before=$($LCTL get_param -n \
-                ldlm.namespaces.$FSNAME-OST0000-osc-[^M]*.lru_size)
+                ldlm.namespaces.$imp_name.lru_size)
 
        wait_osc_import_state client ost1 IDLE
        dd if=/dev/null of=$DIR/$tfile bs=1k count=1 conv=sync
        now=$($LCTL get_param -n \
-             ldlm.namespaces.$FSNAME-OST0000-osc-[^M]*.lru_size)
+             ldlm.namespaces.$imp_name.lru_size)
        [ $before == $now ] || error "lru_size changed $before != $now"
 }
 run_test 816 "do not reset lru_resize on idle reconnect"
@@ -25221,6 +25623,34 @@ test_820() {
 }
 run_test 820 "update max EA from open intent"
 
+test_822() {
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+
+       save_lustre_params mds1 \
+               "osp.$FSNAME-OST*-osc-MDT0000.max_create_count" > $p
+       do_facet $SINGLEMDS "$LCTL set_param -n \
+                       osp.$FSNAME-OST*MDT0000.max_create_count=0"
+       do_facet $SINGLEMDS "$LCTL set_param -n \
+                       osp.$FSNAME-OST0000*MDT0000.max_create_count=20000"
+
+       # wait for statfs update to clear OS_STATFS_NOPRECREATE
+       local maxage=$(do_facet mds1 $LCTL get_param -n \
+                      osp.$FSNAME-OST0000*MDT0000.maxage)
+       sleep $((maxage + 1))
+
+       #define OBD_FAIL_NET_ERROR_RPC          0x532
+       do_facet mds1 "$LCTL set_param fail_loc=0x80000532 fail_val=5"
+
+       stack_trap "restore_lustre_params < $p; rm $p"
+
+       local count=$(do_facet $SINGLEMDS "lctl get_param -n \
+                     osp.$FSNAME-OST0000*MDT0000.create_count")
+       for i in $(seq 1 $count); do
+               touch $DIR/$tfile.${i} || error "touch failed"
+       done
+}
+run_test 822 "test precreate failure"
+
 #
 # tests that do cleanup/setup should be run at the end
 #